
package de.ivu.elect.presentation.email;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.email.boundary.EmailConversationStore;
import de.ivu.elect.business.email.boundary.EmailExtendedDAO;
import de.ivu.elect.business.email.boundary.EmailEdit;
import de.ivu.elect.business.email.entity.Email;
import de.ivu.elect.business.email.entity.EmailMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEmailEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEmailEditNoScopeView.VIEW_ID, useCase = UseCasePermission.EMAIL_EDIT)
public abstract class AbstractEmailEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Email>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailEditView";

  public static final String VIEW_ID = "/email/email-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/email/email-search.xhtml";

  @Inject
  protected transient EmailExtendedDAO extendedDAO;

  @Inject
  protected transient EmailEdit edit;

  @Inject
  @ConversationGroup(EmailConversationStore.class)
  protected transient EmailConversationStore conversationStore;

  @Inject
  protected transient EmailMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient EmailEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Email getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Email entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Email entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.EMAIL_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_EDIT)
  @Override
  public String save() {
    Email entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Email entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Email entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Email entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.EMAIL_EDIT);
  }
  
  @Redirect
  public String edit(Email entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class EmailEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Email,   de.ivu.elect.business.email.entity.EmailPK  > {

    private static final long serialVersionUID = 1L;
  }
}
